/*-
 * Copyright (c) 2000 Andrey Simonenko
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 *
 *  @(#)$Id: db.h,v 1.1.2.3 2000/12/31 18:13:07 simon Exp $
 */

#ifndef IPA_DB_H
#define IPA_DB_H

#include <sys/types.h>
#include <regex.h>

#include "rules.h"

extern u_long		db_uid, db_gid;
extern u_int		db_fileperm, db_dirperm;
extern char		*db_dir;
extern int		lock_db;
extern u_int		lock_wait_time;
extern time_t		curr_time;
extern struct tm	curr_tm;
extern regex_t		reg_db_entry, reg_limit_line1, reg_limit_timestamp;


extern int		init_db(void);
extern int		update_db(struct ipac *, u_quad_t);
extern int		append_db(struct ipac *, u_quad_t);
extern int		mkdir_db(const char *);
extern FILE *		create_db_file(const char *);
extern int		build_db_regexes(void);
extern int		lock_db_file_until_end(char *, int, short);
extern int		unlock_db_file(char *, int);
extern void		loaded_rules_info(void);

#endif /* !IPA_DB_H */